SystemOrganization addCategory: #'tODE-AmberDebugger'!

TOAmberInspectorRenderer subclass: #TOAmberStackFrameRenderer
	instanceVariableNames: ''
	classVariableNames: 'TOASourceArea'
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOAmberStackFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:11'!
context
    ^ self object context! !

!TOAmberStackFrameRenderer methodsFor: 'private' stamp: 'dkh 10/25/2011 19:39'!
convertToLineChar: characterIndex src: src
    | lineCount |
    lineCount := 0.
    src
        lineIndicesDo: [ :start :endNoDelims :end | 
            lineCount := lineCount + 1.
            end >= characterIndex
                ifTrue: [ 
                    ^ {(lineCount - 1).
                    (characterIndex - start + 1)} ] ].
    ^ {(lineCount - 1).
    0}! !

!TOAmberStackFrameRenderer methodsFor: 'expression handling' stamp: 'dkh 10/27/2011 14:57'!
evaluateExpression: exp
    | result o |
    o := self object.
    result := TORoot current currentSession currentSystem
        evaluate: exp
        in: self context
        to: self object receiver
        notifying: self notifier
        ifFail: [ self error: 'evaluation failed' ].
    self object locals at: exp put: result.
    ^ o! !

!TOAmberStackFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/26/2011 20:41'!
getArgMembers
    | members tempNames |
    members := OrderedCollection new.
    tempNames := self context tempNames.
    1 to: self context numArgs do: [ :index | 
        | each |
        each := tempNames at: index.
        members
            add:
                ((TOInspectorKeylessFieldSpec new)
                    keyLabel: each , ':';
                    target: '_blank';
                    value: (self context tempNamed: each)) ].
    members
        add:
            ((TOInspectorValuelessFieldSpec new)
                keyLabel: '---';
                valueLabel: '---').
    ^ members! !

!TOAmberStackFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/26/2011 20:42'!
getContextMembers
    | members tempNames |
    members := OrderedCollection new.
    tempNames := self context tempNames.
    self context numArgs + 1 to: tempNames size do: [ :index | 
        members
            add:
                ((TOInspectorKeylessFieldSpec new)
                    keyLabel: (tempNames at: index);
                    target: '_blank';
                    value: (self context debuggerMap namedTempAt: index in: self context)) ].
    ^ members! !

!TOAmberStackFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/26/2011 20:42'!
getFabricatedMembers
    | members label |
    members := OrderedCollection new.
    members
        add:
                ((TOInspectorKeylessFieldSpec new)
                        keyLabel: '(debugger)';
                        target: '_blank';
                        value: self object debugger);
        add:
                ((TOInspectorKeylessFieldSpec new)
                        keyLabel: '(exception)';
                        target: '_blank';
                        value: self object exception);
        add:
                ((TOInspectorKeylessFieldSpec new)
                        keyLabel: '(receiver)';
                        target: '_blank';
                        value: self object receiver);
        add:
                ((TOInspectorKeylessFieldSpec new)
                        keyLabel: '(thisContext)';
                        target: '_blank';
                        value: self context).
    label := '[]'.
    self object outerFrames
        do: [ :outerFrame | 
            members
                add:
                    ((TOInspectorKeylessFieldSpec new)
                        keyLabel: label;
                        value: outerFrame).
            label := label , ' []' ].
    members
        add:
            ((TOInspectorValuelessFieldSpec new)
                keyLabel: '---';
                valueLabel: '---').
    ^ members! !

!TOAmberStackFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/26/2011 20:42'!
getLocalMembers
    | members |
    self object locals isEmpty
        ifTrue: [ ^ #() ].
    members := OrderedCollection new.
    members
        add:
            ((TOInspectorValuelessFieldSpec new)
                keyLabel: '---';
                valueLabel: '---').
    self object locals
        keysAndValuesDo: [ :exp :result | 
            members
                add:
                    ((TOInspectorKeylessFieldSpec new)
                        keyLabel: exp;
                        target: '_blank';
                        value: result) ].
    ^ members! !

!TOAmberStackFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/26/2011 11:01'!
members
    ^ self getFabricatedMembers, self getArgMembers, self getContextMembers, self getLocalMembers! !

!TOAmberStackFrameRenderer methodsFor: 'metacello' stamp: 'dkh 10/26/2011 09:48'!
packageClass
    ^ self object receiver class theNonMetaClass! !

!TOAmberStackFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 15:05'!
renderBlockMethod
    "[:frame :object :html :main | ...]"

    ^ [ :frame :obj :html :main | 
    html div
        with: [ 
            | stkFrame prev next |
            stkFrame := obj frame.
            prev := stkFrame previous.
            next := stkFrame next.
            next
                ifNotNil: [ 
                    html div
                        with: [ 
                            (html a)
                                href: '#';
                                onClick: [ 
                                            frame session push: (next at: 2).
                                            main renderCenter ];
                                with: [ 
                                            (html span)
                                                style: 'font-size: xx-small; font-weight: bold';
                                                with: (next at: 1) ] ] ].
            html div
                with: [ 
                    | rClass mClass selector |
                    html span with: stkFrame nesting.
                    rClass := stkFrame receiverClass.
                    (html a)
                        href: '#';
                        onClick: [ 
                                    frame session push: (rClass at: 2).
                                    main renderCenter ];
                        with: [ 
                                    (html span)
                                        style: 'font-size: large; font-weight: bold';
                                        with: (rClass at: 1) ].
                    mClass := stkFrame methodClass.
                    (rClass at: 1) ~= (mClass at: 1)
                        ifTrue: [ 
                            (html a)
                                href: '#';
                                onClick: [ 
                                            frame session push: (mClass at: 2).
                                            main renderCenter ];
                                with: [ html span with: '(' , (mClass at: 1) , ')' ] ]
                        ifFalse: [ html with: (mClass at: 1) ].
                    html with: '>>'.
                    selector := stkFrame selector.
                    (html a)
                        href: '#';
                        onClick: [ 
                                    frame session push: (selector at: 2).
                                    main renderCenter ];
                        with: [ 
                                    (html span)
                                        style: 'font-size: large';
                                        with: (selector at: 1) ] ].
            prev
                ifNotNil: [ 
                    html div
                        with: [ 
                            (html a)
                                href: '#';
                                onClick: [ 
                                            frame session push: (prev at: 2).
                                            main renderCenter ];
                                with: [ 
                                            (html span)
                                                style: 'font-size: xx-small; font-weight: bold';
                                                with: (prev at: 1) ] ] ].
            html br.
            html div
                with: [ 
                    prev isNil
                        ifTrue: [ html with: '<<' ]
                        ifFalse: [ 
                            (html a)
                                href: '#';
                                title: (prev at: 1);
                                onClick: [ 
                                            frame session push: (prev at: 2).
                                            main renderCenter ];
                                with: '<<' ].
                    html with: ' --'.
                    (html a)
                        href: '#';
                        onClick: [ 
                                    frame session push: stkFrame debugger.
                                    main renderCenter ];
                        with: '|||'.
                    html with: '-- '.
                    next isNil
                        ifTrue: [ html with: '>>' ]
                        ifFalse: [ 
                            (html a)
                                href: '#';
                                title: (next at: 1);
                                onClick: [ 
                                            frame session push: (next at: 2).
                                            main renderCenter ];
                                with: '>>' ] ].
            html br.
            html div
                with: [ 
                    stkFrame sourceArea
                        ifNil: [ 
                            | sourceArea |
                            sourceArea := (TOASourceArea new)
                                frame: frame;
                                main: main;
                                source: stkFrame methodSource;
                                yourself.
                            sourceArea renderOn: html.
                            sourceArea setSelection: stkFrame srcFrom end: stkFrame srcTo.
                            sourceArea refresh.
                            stkFrame sourceArea: sourceArea ] ] ].
    html br.
    html div
        with: [ 
            html table
                with: [ 
                    obj members
                        do: [ :member | 
                            html tr
                                with: [ 
                                    | td |
                                    td := html td.
                                    td style: 'padding: .3px 4px;'.
                                    td
                                        with: [ 
                                            | key url |
                                            key := member key.
                                            (url := key at: 2) isNil
                                                ifTrue: [ html with: (key at: 1) ]
                                                ifFalse: [ 
                                                    (html a)
                                                        href: '#';
                                                        onClick: [ 
                                                                    frame session push: url.
                                                                    main renderCenter ];
                                                        with: (key at: 1) ] ].
                                    td := html td.
                                    td style: 'padding: .3px 4px;'.
                                    td
                                        with: [ 
                                            | value url |
                                            value := member value.
                                            (url := value at: 2) isNil
                                                ifTrue: [ html with: (value at: 1) ]
                                                ifFalse: [ 
                                                    (html a)
                                                        href: '#';
                                                        onClick: [ 
                                                                    frame session push: url.
                                                                    main renderCenter ];
                                                        with: (value at: 1) ] ] ] ] ] ] ]! !

!TOAmberStackFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 09:28'!
renderContentOn: json
    json
        object: [ 
            json key: 'heading' value: self object exception description.
            self renderFrameOn: json.
            self renderMembersOn: json ]! !

!TOAmberStackFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/26/2011 16:10'!
renderFrame: aFrame context: aContext nested: aStream on: json
    | outerContext |
    (outerContext := aContext outerContext)
        ifNil: [ 
            | src previous next |
            src := aFrame method sourceString withUnixLineEndings.
            json
                key: 'debugger'
                value: [ 
                    json
                        callback: [ 
                            | debugger |
                            debugger := aFrame debugger copy.
                            debugger stackIndex: aFrame stackIndex.
                            self frameComponent object: debugger ] ].
            json key: 'active' value: false.
            json key: 'nesting' value: aStream contents.
            json
                key: 'receiverClass'
                value: [ 
                    json
                        array: [ 
                            json
                                value: aContext receiver class name asString;
                                value: [ 
                                            json
                                                callback: [ 
                                                    (self frameComponent)
                                                        target: '_blank';
                                                        object: aContext receiver class ] ] ] ].
            json
                key: 'methodClass'
                value: [ 
                    json
                        array: [ 
                            json
                                value: aContext method classBinding value name asString;
                                value: [ 
                                            json
                                                callback: [ 
                                                    (self frameComponent)
                                                        target: '_blank';
                                                        object: aContext method classBinding value ] ] ] ].
            json
                key: 'selector'
                value: [ 
                    json
                        array: [ 
                            json
                                value: aContext method selector asString;
                                value: [ 
                                            json
                                                callback: [ 
                                                    (self frameComponent)
                                                        target: '_blank';
                                                        object: aContext method ] ] ] ].
            json key: 'methodSource' value: src.
            self renderFramePCRange: aFrame on: json.
            json key: 'sourceArea' value: nil.
            (previous := aFrame previous) == nil
                ifTrue: [ json key: 'previous' value: nil ]
                ifFalse: [ 
                    json
                        key: 'previous'
                        value: [ 
                            json
                                array: [ 
                                    json
                                        value: previous printString;
                                        value: [ json callback: [ self frameComponent object: previous ] ] ] ] ].
            (next := aFrame next) == nil
                ifTrue: [ json key: 'next' value: nil ]
                ifFalse: [ 
                    json
                        key: 'next'
                        value: [ 
                            json
                                array: [ 
                                    json
                                        value: next printString;
                                        value: [ json callback: [ self frameComponent object: next ] ] ] ] ] ]
        ifNotNil: [ 
            aStream nextPutAll: ' [] in '.
            self
                renderFrame: aFrame
                context: outerContext
                nested: aStream
                on: json ]! !

!TOAmberStackFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/26/2011 14:57'!
renderFrameOn: json
    json
        key: 'frame'
        value: [ 
            json
                object: [ 
                    self
                        renderFrame: self object
                        context: self context
                        nested: (WriteStream on: String new)
                        on: json ] ]! !

!TOAmberStackFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 20:16'!
renderFramePCRange: aFrame on: json
    | src first last from to |
    src := aFrame method sourceString withUnixLineEndings.
    from := to := #(0 0).
    first := aFrame pcRange first.
    last := aFrame pcRange last.
    first < last
        ifTrue: [ 
            from := self convertToLineChar: first - 1 src: src.
            to := self convertToLineChar: last src: src ].
    json
        key: 'srcFrom'
        value: [ 
            json
                object: [ 
                    json key: 'line' value: (from at: 1).
                    json key: 'ch' value: (from at: 2) ] ].
    json
        key: 'srcTo'
        value: [ 
            json
                object: [ 
                    json key: 'line' value: (to at: 1).
                    json key: 'ch' value: (to at: 2) ] ]! !

!TOAmberStackFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/26/2011 09:29'!
renderSessionTitleOn: json
	json render: self object exception description! !

!TOAmberStackFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 09:18'!
renderViewTitleOn: json
	json render: self object printString! !

Object subclass: #TOADebugger
	instanceVariableNames: 'exception frames stackIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOADebugger methodsFor: 'private' stamp: 'dkh 10/26/2011 20:07'!
createFrames
    | context frame previous index |
    frames := OrderedCollection new.
    context := exception signalerContext.
    index := 1.
    frame := (TOAFrame new)
        initialContext: context;
        stackIndex: index;
        debugger: self;
        yourself.
    [ context isNil ]
        whileFalse: [ 
            index := index + 1.
            frames add: frame.
            context := context sender.
            context
                ifNotNil: [ 
                    previous := (TOAFrame new)
                        context: context;
                        stackIndex: index;
                        debugger: self;
                        yourself.
                    frame previous: previous.
                    previous next: frame.
                    frame := previous ] ]! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
exception
    ^exception! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/26/2011 20:00'!
exception: anException
    exception := anException.
    self createFrames.
    self linkOuterFrames! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
frames
    ^frames! !

!TOADebugger methodsFor: 'private' stamp: 'dkh 10/26/2011 20:01'!
linkOuterFrames
    self frames do: [ :frame | frame linkOuterFrames ]! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/26/2011 15:12'!
stackIndex
    ^ stackIndex! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/26/2011 15:12'!
stackIndex: anInteger
    stackIndex := anInteger! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/27/2011 11:22'!
tODEAmberViewRendererClass
    ^ TOAmberStackRenderer! !

Object subclass: #TOAFrame
	instanceVariableNames: 'debugger previous next method context receiver pcRange locals stackIndex outerFrames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:54'!
context

	^context! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:09'!
context: aMethodContext

	context := aMethodContext.
	receiver := context receiver.
	method := MethodReference class: context method classBinding value selector: context method selector.
	pcRange := context debuggerMap rangeForPC: context pc contextIsActiveContext: false.! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:15'!
debugger
	^debugger ! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
debugger: aTOADebugger

	debugger := aTOADebugger! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:10'!
exception
    ^ self debugger exception! !

!TOAFrame methodsFor: 'outer frames' stamp: 'dkh 10/26/2011 20:13'!
findMatchingContext: outerContext
    | p |
    outerContext == self context
        ifTrue: [ ^ self ].
    (p := self previous) ifNil: [ ^ nil ].
    ^ p findMatchingContext: outerContext! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:16'!
initialContext: aMethodContext
    context := aMethodContext.
    receiver := context receiver.
    method := MethodReference class: context method classBinding value selector: context method selector.
    pcRange := context debuggerMap rangeForPC: context pc contextIsActiveContext: true! !

!TOAFrame methodsFor: 'outer frames' stamp: 'dkh 10/26/2011 20:21'!
linkOuterFrames
    | outerContext outerFrame |
    outerFrames ifNotNil: [ ^ outerFrames ].
    (outerContext := self context outerContext) ifNil: [ ^ self outerFrames ].
    (outerFrame := self findMatchingContext: outerContext)
        ifNotNil: [ 
            (self outerFrames)
                add: outerFrame;
                addAll: outerFrame linkOuterFrames ].
    ^ self outerFrames! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/26/2011 10:57'!
locals
    locals ifNil: [ locals := Dictionary new ].
    ^ locals! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 12:01'!
method
    ^ method! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:02'!
next

	^next ! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:49'!
next: aTOAFrame

	next := aTOAFrame! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/26/2011 19:59'!
outerFrames
    outerFrames ifNil: [ outerFrames := OrderedCollection new ].
    ^ outerFrames! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:12'!
pcRange

	^pcRange! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:04'!
previous

	^previous! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:50'!
previous: aTOAFrame

	previous := aTOAFrame! !

!TOAFrame methodsFor: 'printing' stamp: 'dkh 10/24/2011 09:53'!
printContext: aContext on: aStream
	| outerContext |
	(outerContext := aContext outerContext)
		ifNil: [aContext  printOn: aStream]
		ifNotNil:
			[
			 aStream nextPutAll: ' [] in '.
			 self printContext: outerContext on: aStream]! !

!TOAFrame methodsFor: 'printing' stamp: 'dkh 10/24/2011 09:54'!
printOn: aStream
	self printContext: self context on: aStream! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 12:02'!
receiver
    ^ receiver! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/26/2011 14:54'!
stackIndex
    ^ stackIndex! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/26/2011 14:54'!
stackIndex: anInteger
    stackIndex := anInteger! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/27/2011 11:22'!
tODEAmberViewRendererClass
    ^ TOAmberStackFrameRenderer! !

!TOAmberErrorHandler methodsFor: '*tode-amberdebugger' stamp: 'dkh 10/26/2011 19:49'!
open: anException
    | component |
    [ 
    (anException isKindOf: Halt)
        ifTrue: [ ^ super open: anException ].
    component := (TOAmberFrameComponent new)
        object:
                ((TOADebugger new)
                        exception: anException;
                        yourself);
        target: '_blank';
        yourself.
    self session presenter call: component onAnswer: [  ] ] on: Error do: [ :ex | super open: ex ]! !

TOAmberViewRenderer subclass: #TOAmberStackRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOAmberStackRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 11:33'!
renderBlockMethod
    "[:frame :object :html :main | ...]"

    ^ [ :frame :obj :html :main | 
    | selectedFrameIndex count |
    selectedFrameIndex := obj selectedFrameIndex.
    count := 1.
    obj frames
        do: [ :frm | 
            (html a)
                href: '#';
                onClick: [ 
                            frame session push: frm url.
                            main renderCenter ];
                with: [ 
                            | stkFrame style |
                            stkFrame := frm frame.
                            html span with: stkFrame nesting.
                            style := 'font-weight: bold;'.
                            selectedFrameIndex = count
                                ifTrue: [ style := style , 'background-color: #CCFF00' ].
                            (html span)
                                style: style;
                                with: stkFrame receiverClass.
                            stkFrame receiverClass ~= stkFrame methodClass
                                ifTrue: [ 
                                    (html span)
                                        style: 'font-size: x-small';
                                        with: '(' , stkFrame methodClass , ')' ].
                            html with: '>>'.
                            (html span)
                                style: style;
                                with: stkFrame selector ].
            html br.
            count := count + 1 ] ]! !

!TOAmberStackRenderer methodsFor: 'rendering' stamp: 'dkh 10/26/2011 15:44'!
renderContentOn: json
    json
        object: [ 
            json key: 'selectedFrameIndex' value: self object stackIndex.
            json
                key: 'frames'
                value: [ 
                    json
                        array: [ 
                            self object frames
                                do: [ :frame | 
                                    json
                                        value: [ 
                                            json
                                                object: [ 
                                                    json
                                                        key: 'frame'
                                                        value: [ 
                                                            json
                                                                object: [ 
                                                                    self
                                                                        renderFrame: frame
                                                                        context: frame context
                                                                        nested: (WriteStream on: String new)
                                                                        on: json ] ].
                                                    json
                                                        key: 'url'
                                                        value: [ json callback: [ self frameComponent object: frame ] ] ] ] ] ] ] ]! !

!TOAmberStackRenderer methodsFor: 'rendering' stamp: 'dkh 10/26/2011 15:41'!
renderFrame: aFrame context: aContext nested: aStream on: json
    | outerContext |
    (outerContext := aContext outerContext)
        ifNil: [ 
            json key: 'nesting' value: aStream contents.
            json key: 'receiverClass' value: aContext receiver class name asString.
            json key: 'methodClass' value: aContext method classBinding value name asString.
            json key: 'selector' value: aContext method selector asString ]
        ifNotNil: [ 
            aStream nextPutAll: ' [] in '.
            self
                renderFrame: aFrame
                context: outerContext
                nested: aStream
                on: json ]! !

!TOAmberStackRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 09:18'!
renderViewTitleOn: json
	json render: self object exception description! !
